package com.yice.webadmin.app.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.github.pagehelper.Page;
import com.yice.common.core.base.dao.BaseDaoMapper;
import com.yice.common.core.base.service.BaseService;
import com.yice.common.core.object.CallResult;
import com.yice.common.core.object.MyRelationParam;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.dict.service.GlobalDictService;
import com.yice.common.sequence.wrapper.IdGeneratorWrapper;
import com.yice.webadmin.app.dao.PromptTemplateMapper;
import com.yice.webadmin.app.model.PromptTemplate;
import com.yice.webadmin.app.service.PromptTemplateService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 提示词模板数据操作服务类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Slf4j
@Service("promptTemplateService")
public class PromptTemplateServiceImpl extends BaseService<PromptTemplate, Long> implements PromptTemplateService {

    @Autowired
    private PromptTemplateMapper promptTemplateMapper;
    @Autowired
    private GlobalDictService globalDictService;
    @Autowired
    private IdGeneratorWrapper idGenerator;

    /**
     * 返回当前Service的主表Mapper对象。
     *
     * @return 主表Mapper对象。
     */
    @Override
    protected BaseDaoMapper<PromptTemplate> mapper() {
        return promptTemplateMapper;
    }

    /**
     * 保存新增对象。
     *
     * @param promptTemplate 新增对象。
     * @return 返回新增对象。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public PromptTemplate saveNew(PromptTemplate promptTemplate) {
        promptTemplateMapper.insert(this.buildDefaultValue(promptTemplate));
        return promptTemplate;
    }

    /**
     * 利用数据库的insertList语法，批量插入对象列表。
     *
     * @param promptTemplateList 新增对象列表。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveNewBatch(List<PromptTemplate> promptTemplateList) {
        if (CollUtil.isNotEmpty(promptTemplateList)) {
            promptTemplateList.forEach(this::buildDefaultValue);
            promptTemplateMapper.insertList(promptTemplateList);
        }
    }

    /**
     * 更新数据对象。
     *
     * @param promptTemplate         更新的对象。
     * @param originalPromptTemplate 原有数据对象。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean update(PromptTemplate promptTemplate, PromptTemplate originalPromptTemplate) {
        MyModelUtil.fillCommonsForUpdate(promptTemplate, originalPromptTemplate);
        // 这里重点提示，在执行主表数据更新之前，如果有哪些字段不支持修改操作，请用原有数据对象字段替换当前数据字段。
        UpdateWrapper<PromptTemplate> uw = this.createUpdateQueryForNullValue(promptTemplate, promptTemplate.getTemplateId());
        return promptTemplateMapper.update(promptTemplate, uw) == 1;
    }

    /**
     * 删除指定数据。
     *
     * @param templateId 主键Id。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean remove(Long templateId) {
        return promptTemplateMapper.deleteById(templateId) == 1;
    }

    /**
     * 获取单表查询结果。由于没有关联数据查询，因此在仅仅获取单表数据的场景下，效率更高。
     * 如果需要同时获取关联数据，请移步(getPromptTemplateListWithRelation)方法。
     *
     * @param filter  过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<PromptTemplate> getPromptTemplateList(PromptTemplate filter, String orderBy) {
        return promptTemplateMapper.getPromptTemplateList(filter, orderBy);
    }

    /**
     * 获取主表的查询结果，以及主表关联的字典数据和一对一从表数据，以及一对一从表的字典数据。
     * 该查询会涉及到一对一从表的关联过滤，或一对多从表的嵌套关联过滤，因此性能不如单表过滤。
     * 如果仅仅需要获取主表数据，请移步(getPromptTemplateList)，以便获取更好的查询性能。
     *
     * @param filter  主表过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<PromptTemplate> getPromptTemplateListWithRelation(PromptTemplate filter, String orderBy) {
        List<PromptTemplate> resultList = promptTemplateMapper.getPromptTemplateList(filter, orderBy);
        // 在缺省生成的代码中，如果查询结果resultList不是Page对象，说明没有分页，那么就很可能是数据导出接口调用了当前方法。
        // 为了避免一次性的大量数据关联，规避因此而造成的系统运行性能冲击，这里手动进行了分批次读取，开发者可按需修改该值。
        int batchSize = resultList instanceof Page ? 0 : 1000;
        this.buildRelationForDataList(resultList, MyRelationParam.normal(), batchSize);
        return resultList;
    }

    @Override
    public List<PromptTemplate> getPromptTemplateForCollectListWithRelation(PromptTemplate filter, String orderBy) {
        List<PromptTemplate> resultList = promptTemplateMapper.getPromptTemplateForCollectList(filter, orderBy);
        // 在缺省生成的代码中，如果查询结果resultList不是Page对象，说明没有分页，那么就很可能是数据导出接口调用了当前方法。
        // 为了避免一次性的大量数据关联，规避因此而造成的系统运行性能冲击，这里手动进行了分批次读取，开发者可按需修改该值。
        int batchSize = resultList instanceof Page ? 0 : 1000;
        this.buildRelationForDataList(resultList, MyRelationParam.normal(), batchSize);
        return resultList;
    }

    /**
     * 根据最新对象和原有对象的数据对比，判断关联的字典数据和多对一主表数据是否都是合法数据。
     *
     * @param promptTemplate         最新数据对象。
     * @param originalPromptTemplate 原有数据对象。
     * @return 数据全部正确返回true，否则false。
     */
    @Override
    public CallResult verifyRelatedData(PromptTemplate promptTemplate, PromptTemplate originalPromptTemplate) {
        String errorMessageFormat = "数据验证失败，关联的%s并不存在，请刷新后重试！";
        //这里是基于字典的验证。
        if (this.needToVerify(promptTemplate, originalPromptTemplate, PromptTemplate::getTemplateSource)
                && !globalDictService.existDictItemFromCache("TemplateSourceLabel", promptTemplate.getTemplateSource())) {
            return CallResult.error(String.format(errorMessageFormat, "模板来源"));
        }
        //这里是基于字典的验证。
        if (this.needToVerify(promptTemplate, originalPromptTemplate, PromptTemplate::getScenarioType)
                && !globalDictService.existDictItemFromCache("ScenarioTypeLabel", promptTemplate.getScenarioType())) {
            return CallResult.error(String.format(errorMessageFormat, "场景类型"));
        }
        //这里是基于字典的验证。
        if (this.needToVerify(promptTemplate, originalPromptTemplate, PromptTemplate::getTemplateFramework)
                && !globalDictService.existDictItemFromCache("TemplateFrameworkLabel", promptTemplate.getTemplateFramework())) {
            return CallResult.error(String.format(errorMessageFormat, "模板框架"));
        }
        //这里是基于字典的验证。
        if (this.needToVerify(promptTemplate, originalPromptTemplate, PromptTemplate::getParameterFormat)
                && !globalDictService.existDictItemFromCache("ParameterFormatLabel", promptTemplate.getParameterFormat())) {
            return CallResult.error(String.format(errorMessageFormat, "参数格式"));
        }
        return CallResult.ok();
    }

    private PromptTemplate buildDefaultValue(PromptTemplate promptTemplate) {
        if (promptTemplate.getTemplateId() == null) {
            promptTemplate.setTemplateId(idGenerator.nextLongId());
        }
        MyModelUtil.fillCommonsForInsert(promptTemplate);
        return promptTemplate;
    }
}
